stages:
  - build
  - test
  - publish
  - deploy
  
build:
  stage: build
  #image: microsoft/dotnet:2.1-sdk-alpine
  script:
    - dotnet restore
    - dotnet build --no-restore
    - dotnet publish -c Release -o /app/publish
  artifacts:
    paths:
     - ./obj
  only:
    - main

unit-test:
  stage: test
  script:
    - dotnet test --no-build
  only:
    - main

publish:
  stage: publish
  image: docker:dind
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_HOST: tcp://docker:2375
  only:
    - main
  before_script:
    - docker login -u "gitlab-ci-token" -p "$CI_JOB_TOKEN" $CI_REGISTRY
  script:
    - docker build --tag "$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA" --tag "$CI_REGISTRY_IMAGE:latest" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA"
    - docker push "$CI_REGISTRY_IMAGE:latest"

production:
  stage: deploy
  image: alpine:latest
  script:
  - chmod og= $ID_RSA
  - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY"
  - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker pull $TAG_COMMIT"
  - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker container rm -f asp-netcore-webapi || true"
  - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker run -d -p 80:80 --name asp-netcore-webapi $TAG_COMMIT"
  environment: 
    name: production
  only:
    - main
  when: manual
  dependencies:
    - build